
  <!DOCTYPE html>
  <html>
    <head>
      <title>index.tsx</title>
      <link href="https://cdn.jsdelivr.net/npm/semantic-ui@2.4.2/dist/semantic.min.css" type="text/css" rel="stylesheet">
      <script src="https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.58.2/codemirror.min.js" type="text/javascript" charset="utf-8"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.58.2/mode/javascript/javascript.min.js" type="text/javascript" charset="utf-8"></script>
<link href="https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.58.2/codemirror.min.css" type="text/css" rel="stylesheet">
<script src="../../../../assets/source-file.js" type="text/javascript" charset="utf-8"></script>
<link href="../../../../assets/source-file.css" type="text/css" rel="stylesheet">
    </head>
    <body>
    <div style="margin-top:3em" class="ui container"><h1 class="ui header"><a href="../../../../index.html">TypeScript coverage report</a></h1><table style="margin-top:2em" class="ui celled table"><thead class=""><tr class=""><th class="">Filename</th><th class="">Percent</th><th class="">Threshold</th><th class="">Total</th><th class="">Covered</th><th class="">Uncovered</th></tr></thead><tbody class=""><tr class="positive"><td class="">src/pages/fitting/index.tsx</td><td class="">90.91%</td><td class="">80%</td><td class="">1067</td><td class="">970</td><td class="">97</td></tr></tbody></table><textarea id="editor" readonly="" style="margin-top:3em">import React, { useCallback, useEffect, useMemo, useState } from &#x27;react&#x27;;

import s from &#x27;./model-configuring.module.scss&#x27;;
import { Header } from &#x27;../../components/Header/Header&#x27;;
import {
  Graphic,
  Heading,
  HeadingVariant,
  SelectedPoint
} from &#x27;../../components&#x27;;
import { Button, ButtonVariant } from &#x27;../../components/Button/Button&#x27;;
import { ReactComponent as SaveAndContinueIcon } from &#x27;./assets/save-and-continue.svg&#x27;;
import { Paths } from &#x27;../../routes/paths&#x27;;
import { useHistory, useParams } from &#x27;react-router-dom&#x27;;
import { mapRowsToObject } from &#x27;../projects&#x27;;
import { ProjectBreadcrumbs } from &#x27;../project-settings&#x27;;
import { useInitialData, useProject } from &#x27;../../queries/projects&#x27;;
import {
  useGrowthKinetics,
  useUpdateGrowthKinetics
} from &#x27;../../queries/simulation&#x27;;
import { LastSaved } from &#x27;../model-configuring&#x27;;
import { useRenderTooltip } from &#x27;./hooks/useRenderTooltip&#x27;;
import { useXAxis } from &#x27;./hooks/useXAxis&#x27;;
import { useLines } from &#x27;./hooks/useLines&#x27;;
import { MultiSelect } from &#x27;../../components/MultiSelect/MultiSelect&#x27;;

const Info = ({
  fields,
  title
}: {
  title: string;
  fields: { name: string; value: string | number }[];
}) =&gt; {
  return (
    &lt;div className={s.Info}&gt;
      &lt;div className={s.Info__title}&gt;{title}&lt;/div&gt;
      &lt;div className={s.Info__content}&gt;
        {fields.map((field) =&gt; {
          return (
            &lt;div key={field.name} className={s.Info__item}&gt;
              &lt;div className={s.Info__itemName}&gt;{field.name}&lt;/div&gt;
              &lt;div className={s.Info__itemValue}&gt;{field.value}&lt;/div&gt;
            &lt;/div&gt;
          );
        })}
      &lt;/div&gt;
    &lt;/div&gt;
  );
};

const addColumnValue = (
  prepared: any[],
  mappedSimulatedData: { batchName: string; data: {}[] }[],
  columnName: string
) =&gt; {
  return prepared
    .map((row, idx) =&gt; {
      return {
        ...row,
        [row.BatchID]: row[columnName]
      };
    })
    .concat(
      mappedSimulatedData.reduce((acc, { batchName, data: rows }) =&gt; {
        return acc.concat(
          rows.map((row) =&gt; ({
            ...row,
            [`predicted${batchName}`]: (row as any)[columnName]
          }))
        );
      }, [] as any[])
    )
    .map((row) =&gt; ({
      ...row,
      [row.BatchID]: row[columnName] || null
    }))
    .sort((a, b) =&gt; a.Time - b.Time);
};

const formatIfNumber = (
  value: string | number | undefined | null,
  nums = 4
) =&gt; {
  if (typeof value === &#x27;string&#x27; || typeof value === &#x27;number&#x27;) {
    const isValid = isFinite(parseFloat(value.toString()));
    if (isValid) {
      return parseFloat(value.toString()).toFixed(nums);
    }
  }
  return &#x27;-&#x27;;
};

const computeExcludedPointsToGraphic = (
  graphicData: { BatchID: string; Time: number; [key: string]: any }[],
  excludedPoints: SelectedPoint&lt;string&gt;[],
  field: string
): SelectedPoint&lt;string&gt;[] =&gt; {
  return excludedPoints.map((point) =&gt; {
    const graphicPoint = graphicData.find(
      (gp) =&gt; gp.BatchID === point.dataKey &amp;&amp; gp.Time === point.x
    );

    return {
      dataKey: point.dataKey,
      id: point.id,
      x: graphicPoint?.Time || null,
      y: graphicPoint?.[field] || null
    };
  });
};

const computeSelectedPointToGraphic = (
  graphicData: { BatchID: string; Time: number; [key: string]: any }[],
  selectedPoint: SelectedPoint&lt;string&gt; | null,
  field: string
) =&gt; {
  if (!selectedPoint) return null;
  const graphicPoint = graphicData.find(
    (gp) =&gt; gp.BatchID === selectedPoint.dataKey &amp;&amp; gp.Time === selectedPoint.x
  );
  if (!graphicPoint) return null;
  return {
    dataKey: graphicPoint.dataKey,
    id: graphicPoint.id,
    x: graphicPoint?.Time || null,
    y: graphicPoint?.[field] || null
  };
};

const columns = {
  batchId: &#x27;BatchID&#x27;,
  viableCellDensity: &#x27;Viable cell density&#x27;,
  viability: &#x27;Cell viability&#x27;,
  time: &#x27;Time&#x27;
} as const;
export const FittingPage = () =&gt; {
  const { projectId } = useParams&lt;{ projectId: string }&gt;();
  const project = useProject(projectId);
  const initialData = useInitialData(projectId)?.data;
  const columnsMap = useMemo(() =&gt; {
    const BatchID =
      project.project?.columns_map?.[columns.batchId] || columns.batchId;
    const viableCellDensity =
      project.project?.columns_map?.[columns.viableCellDensity] ||
      columns.viableCellDensity;
    const viability =
      project.project?.columns_map?.[columns.viability] || columns.viability;
    const time = project.project?.columns_map?.[columns.time] || columns.time;
    return {
      BatchID,
      viableCellDensity,
      viability,
      time
    };
  }, [project.project?.columns_map]);
  const mapInitialColumnNamesToSystemColumnNames = useCallback(
    (data: object[]) =&gt; {
      return (data || []).map((id: any) =&gt; {
        return {
          ...id,
          [columns.batchId]: id[columnsMap.BatchID],
          [columns.time]: id[columnsMap.time],
          [columns.viableCellDensity]: id[columnsMap.viableCellDensity],
          [columns.viability]: id[columnsMap.viability]
        };
      });
    },
    [columnsMap]
  );
  const mappedInitialData = useMemo(
    () =&gt; mapInitialColumnNamesToSystemColumnNames(initialData || []),
    [initialData, mapInitialColumnNamesToSystemColumnNames]
  );

  const batchNames = useMemo(() =&gt; {
    const set = new Set(
      mappedInitialData.map((row: any) =&gt; {
        return row[columnsMap.BatchID];
      })
    );
    const ret: string[] = [];
    set.forEach((v) =&gt; ret.push(v.toString()));
    return ret;
  }, [columnsMap.BatchID, mappedInitialData]);

  const [selectedInSelectorBatch, setSelectedInSelectorBatch] = useState&lt;
    string | undefined
  &gt;(batchNames[0]);

  const { data: fittingData } = useGrowthKinetics({
    projectId
  });

  useEffect(() =&gt; {
    if (selectedInSelectorBatch === undefined) {
      setSelectedInSelectorBatch(batchNames[0]);
    }
  }, [batchNames, selectedInSelectorBatch]);
  const mappedSimulatedData = useMemo(() =&gt; {
    return fittingData?.simulated_data || [];
  }, [fittingData]);

  const mappedInitialDataVariablesNames = useMemo(() =&gt; {
    return Object.keys(
      mappedInitialData.reduce((acc, row) =&gt; ({ ...acc, ...row }), {})
    );
  }, [mappedInitialData]);

  const mappedFittingDataVariablesNames = useMemo(() =&gt; {
    return Object.keys(
      mappedSimulatedData.reduce(
        (acc, row) =&gt; ({
          ...acc,
          ...row.data.reduce((acc2, row2) =&gt; ({ ...acc2, ...row2 }), {})
        }),
        {}
      )
    );
  }, [mappedSimulatedData]);

  const variablesNames = useMemo(
    () =&gt;
      Object.keys(
        mappedInitialDataVariablesNames
          .concat(mappedFittingDataVariablesNames)
          .reduce((acc, variable) =&gt; ({ ...acc, [variable]: true }), {})
      ),
    [mappedInitialDataVariablesNames, mappedFittingDataVariablesNames]
  );

  // FIXME: not string type in &lt;&gt;
  const [selectedPoint, onSelectPoint] = useState&lt;SelectedPoint&lt;string&gt; | null&gt;(
    null
  );
  const [selectedPoints, onChangeSelectedPoints] = useState&lt;
    SelectedPoint&lt;string&gt;[]
  &gt;([]);
  const [selectedBatches, onChangeSelectedBatches] = useState&lt;string[]&gt;([]);
  const [excludedPoints, onChangeExcludedPoints] = useState&lt;
    SelectedPoint&lt;string&gt;[]
  &gt;([]);
  const [excludedBatches, onChangeExcludedBatches] = useState&lt;string[]&gt;([]);

  const viableCellDensity = useMemo(
    () =&gt;
      addColumnValue(
        mappedInitialData,
        mappedSimulatedData,
        columns.viableCellDensity
      ),
    [mappedInitialData, mappedSimulatedData]
  );

  const viability = useMemo(
    () =&gt;
      addColumnValue(mappedInitialData, mappedSimulatedData, columns.viability),
    [mappedInitialData, mappedSimulatedData]
  );
  const [selected1, setSelected1] = useState(&#x27;&#x27;);
  const variableSelector1 = useMemo(() =&gt; {
    if (!selected1) return [];
    return addColumnValue(mappedInitialData, mappedSimulatedData, selected1);
  }, [mappedSimulatedData, mappedInitialData, selected1]);
  const [selected2, setSelected2] = useState(&#x27;&#x27;);
  const variableSelector2 = useMemo(() =&gt; {
    if (!selected2) return [];
    return addColumnValue(mappedInitialData, mappedSimulatedData, selected2);
  }, [mappedSimulatedData, mappedInitialData, selected2]);
  const [selected3, setSelected3] = useState(&#x27;&#x27;);
  const variableSelector3 = useMemo(() =&gt; {
    if (!selected3) return [];
    return addColumnValue(mappedInitialData, mappedSimulatedData, selected3);
  }, [mappedSimulatedData, mappedInitialData, selected3]);

  const history = useHistory();

  const [isLoading, setLoading] = useState(false);

  const { mutate: mutateGrowthKinetics } = useUpdateGrowthKinetics();
  const handleRecalculate = useCallback(() =&gt; {
    setLoading(true);

    const columnsMap = project.project?.columns_map || null;
    const notTransformed = mappedInitialData
      .filter((row) =&gt; {
        if (excludedBatches.includes(row.BatchID)) {
          return false;
        }
        if (
          excludedPoints.find(
            (point) =&gt; point.dataKey === row.BatchID &amp;&amp; point.x === row.Time
          )
        ) {
          return false;
        }
        return true;
      })
      .map((row) =&gt; {
        if (!columnsMap) {
          return row;
        }
        if (columnsMap[columns.viability] !== columns.viability) {
          delete row[columns.viability];
        }
        if (
          columnsMap[columns.viableCellDensity] !== columns.viableCellDensity
        ) {
          delete row[columns.viableCellDensity];
        }
        if (columnsMap[columns.batchId] !== columns.batchId) {
          delete row[columns.batchId];
        }
        if (columnsMap[columns.time] !== columns.time) {
          delete row[columns.time];
        }
        return row;
      });
    const dataSet = mapRowsToObject(notTransformed);

    mutateGrowthKinetics({
      projectId,
      batchId: selectedInSelectorBatch as string,
      data: dataSet
    });
  }, [
    excludedBatches,
    excludedPoints,
    mappedInitialData,
    mutateGrowthKinetics,
    project.project?.columns_map,
    projectId,
    selectedInSelectorBatch
  ]);

  const vccRenderTooltip = useRenderTooltip(&#x27;VCC&#x27;);
  const viabilityRenderTooltip = useRenderTooltip(&#x27;Viability&#x27;);
  const selected1RenderTooltip = useRenderTooltip(selected1);
  const selected2RenderTooltip = useRenderTooltip(selected2);
  const selected3RenderTooltip = useRenderTooltip(selected3);
  const xAxis = useXAxis();
  const lines = useLines(batchNames, selectedBatches, excludedBatches);
  const commonGraphicsProps = {
    xAxis,
    showIncludeExcludeControls: true,
    connectPointsByLines: false,
    selectedPoints,
    onChangeSelectedPoints,
    selectedBatches,
    onChangeSelectedBatches,
    excludedPoints,
    onChangeExcludedPoints,
    excludedBatches,
    onChangeExcludedBatches,
    selectedPoint,
    onSelectPoint,
    lines
  };

  return (
    &lt;div className={s.ProjectSettings}&gt;
      &lt;Header /&gt;
      &lt;ProjectBreadcrumbs /&gt;
      &lt;div className={s.ProjectSettings__content}&gt;
        &lt;div className={s.ModelConfiguring__contentLeft}&gt;
          &lt;Heading
            className={s.ProjectSettings__headingH2}
            variant={HeadingVariant.H2}
          &gt;
            Fitting: Growth Kinetics
          &lt;/Heading&gt;
          &lt;LastSaved /&gt;
        &lt;/div&gt;
        &lt;Button
          hoverVariant={ButtonVariant.ACTION}
          rightIcon={&lt;SaveAndContinueIcon /&gt;}
          uppercase
          size=&quot;small&quot;
          onClick={() =&gt; {
            history.push(
              Paths.CLONE_SELECTION_SIMULATION.replace(
                /:projectId/gi,
                projectId
              )
            );
          }}
        &gt;
          Save &amp; Continue
        &lt;/Button&gt;
      &lt;/div&gt;
      &lt;div className={s.Fitting__recalculateWrapper}&gt;
        &lt;div&gt;
          &lt;div className={s.Fitting__recalculateLabel}&gt;Batch selector&lt;/div&gt;
          &lt;div&gt;
            &lt;MultiSelect
              value={selectedBatches}
              onChange={onChangeSelectedBatches}
              options={batchNames.map((batchName) =&gt; ({
                value: batchName,
                label: batchName
              }))}
            /&gt;
          &lt;/div&gt;
        &lt;/div&gt;
        &lt;Button
          uppercase
          variant={ButtonVariant.ACTION}
          onClick={handleRecalculate}
          disabled={isLoading}
        &gt;
          Recalculate
        &lt;/Button&gt;
      &lt;/div&gt;
      &lt;div className={s.ModelConfiguring__frames}&gt;
        &lt;div&gt;
          &lt;div&gt;
            &lt;div className={s.Fitting__recalculateLabel}&gt;
              Measured and Predicted Fit
            &lt;/div&gt;
            &lt;div className={s.Fitting__measuredVsPredictedFit}&gt;
              &lt;div&gt;
                &lt;div
                  style={{
                    height: &#x27;calc(100vh - 300px + 35px)&#x27;,
                    width: &#x27;100%&#x27;,
                    border: &#x27;1px solid #BDBDBD&#x27;
                  }}
                &gt;
                  &lt;Graphic
                    data={viableCellDensity}
                    renderTooltip={vccRenderTooltip}
                    yAxisUnit={columns.viableCellDensity}
                    {...commonGraphicsProps}
                    selectedPoint={computeSelectedPointToGraphic(
                      viableCellDensity,
                      commonGraphicsProps.selectedPoint,
                      columns.viableCellDensity
                    )}
                    selectedPoints={computeExcludedPointsToGraphic(
                      viableCellDensity,
                      selectedPoints,
                      columns.viableCellDensity
                    )}
                    excludedPoints={computeExcludedPointsToGraphic(
                      viableCellDensity,
                      excludedPoints,
                      columns.viableCellDensity
                    )}
                  /&gt;
                &lt;/div&gt;
                &lt;div className={s.Fitting__variableName}&gt;
                  Viable cell density
                &lt;/div&gt;
              &lt;/div&gt;

              &lt;div&gt;
                &lt;div
                  style={{
                    height: &#x27;calc(100vh - 300px + 35px)&#x27;,
                    width: &#x27;100%&#x27;,
                    border: &#x27;1px solid #BDBDBD&#x27;
                  }}
                &gt;
                  &lt;Graphic
                    data={viability}
                    yAxisUnit={columns.viability}
                    renderTooltip={viabilityRenderTooltip}
                    {...commonGraphicsProps}
                    selectedPoint={computeSelectedPointToGraphic(
                      viability,
                      commonGraphicsProps.selectedPoint,
                      columns.viability
                    )}
                    selectedPoints={computeExcludedPointsToGraphic(
                      viability,
                      selectedPoints,
                      columns.viability
                    )}
                    excludedPoints={computeExcludedPointsToGraphic(
                      viability,
                      excludedPoints,
                      columns.viability
                    )}
                  /&gt;
                &lt;/div&gt;
                &lt;div className={s.Fitting__variableName}&gt;Viability&lt;/div&gt;
              &lt;/div&gt;
            &lt;/div&gt;
            &lt;div className={s.Fitting__recalculateLabel}&gt;
              Variable Trajectories
            &lt;/div&gt;
            &lt;div className={s.Fitting__variablesGraphics}&gt;
              &lt;div&gt;
                &lt;div className={s.Fitting__variablesGraphicsSelect}&gt;
                  &lt;div className={s.Fitting__recalculateSelectWrapper}&gt;
                    &lt;select
                      value={selected1}
                      onChange={(e) =&gt; setSelected1(e.target.value)}
                      className={s.Fitting__recalculateSelect}
                    &gt;
                      &lt;option value=&quot;&quot;&gt;Select variable&lt;/option&gt;
                      {variablesNames.map((col) =&gt; (
                        &lt;option key={col} value={col}&gt;
                          {col}
                        &lt;/option&gt;
                      ))}
                    &lt;/select&gt;
                  &lt;/div&gt;
                &lt;/div&gt;
                &lt;div
                  style={{
                    marginTop: &#x27;10px&#x27;,
                    height: &#x27;400px&#x27;,
                    width: &#x27;23vw&#x27;
                  }}
                &gt;
                  &lt;Graphic
                    data={variableSelector1}
                    yAxisUnit={selected1}
                    renderTooltip={selected1RenderTooltip}
                    {...commonGraphicsProps}
                    selectedPoint={computeSelectedPointToGraphic(
                      variableSelector1,
                      commonGraphicsProps.selectedPoint,
                      selected1
                    )}
                    selectedPoints={computeExcludedPointsToGraphic(
                      variableSelector1,
                      selectedPoints,
                      selected1
                    )}
                    excludedPoints={computeExcludedPointsToGraphic(
                      variableSelector1,
                      excludedPoints,
                      selected1
                    )}
                  /&gt;
                &lt;/div&gt;
              &lt;/div&gt;
              &lt;div&gt;
                &lt;div className={s.Fitting__variablesGraphicsSelect}&gt;
                  &lt;div className={s.Fitting__recalculateSelectWrapper}&gt;
                    &lt;select
                      value={selected2}
                      onChange={(e) =&gt; setSelected2(e.target.value)}
                      className={s.Fitting__recalculateSelect}
                    &gt;
                      &lt;option value=&quot;&quot;&gt;Select variable&lt;/option&gt;
                      {variablesNames.map((col) =&gt; (
                        &lt;option key={col} value={col}&gt;
                          {col}
                        &lt;/option&gt;
                      ))}
                    &lt;/select&gt;
                  &lt;/div&gt;
                &lt;/div&gt;
                &lt;div
                  style={{
                    marginTop: &#x27;10px&#x27;,
                    height: &#x27;400px&#x27;,
                    width: &#x27;23vw&#x27;
                  }}
                &gt;
                  &lt;Graphic
                    data={variableSelector2}
                    yAxisUnit={selected2}
                    renderTooltip={selected2RenderTooltip}
                    {...commonGraphicsProps}
                    selectedPoint={computeSelectedPointToGraphic(
                      variableSelector2,
                      commonGraphicsProps.selectedPoint,
                      selected2
                    )}
                    selectedPoints={computeExcludedPointsToGraphic(
                      variableSelector2,
                      selectedPoints,
                      selected2
                    )}
                    excludedPoints={computeExcludedPointsToGraphic(
                      variableSelector2,
                      excludedPoints,
                      selected2
                    )}
                  /&gt;
                &lt;/div&gt;
              &lt;/div&gt;
              &lt;div&gt;
                &lt;div className={s.Fitting__variablesGraphicsSelect}&gt;
                  &lt;div className={s.Fitting__recalculateSelectWrapper}&gt;
                    &lt;select
                      value={selected3}
                      onChange={(e) =&gt; setSelected3(e.target.value)}
                      className={s.Fitting__recalculateSelect}
                    &gt;
                      &lt;option value=&quot;&quot;&gt;Select variable&lt;/option&gt;
                      {variablesNames.map((col) =&gt; (
                        &lt;option key={col} value={col}&gt;
                          {col}
                        &lt;/option&gt;
                      ))}
                    &lt;/select&gt;
                  &lt;/div&gt;
                &lt;/div&gt;
                &lt;div
                  style={{
                    marginTop: &#x27;10px&#x27;,
                    height: &#x27;400px&#x27;,
                    width: &#x27;23vw&#x27;
                  }}
                &gt;
                  &lt;Graphic
                    data={variableSelector3}
                    yAxisUnit={selected3}
                    renderTooltip={selected3RenderTooltip}
                    {...commonGraphicsProps}
                    selectedPoint={computeSelectedPointToGraphic(
                      variableSelector3,
                      commonGraphicsProps.selectedPoint,
                      selected3
                    )}
                    selectedPoints={computeExcludedPointsToGraphic(
                      variableSelector3,
                      selectedPoints,
                      selected3
                    )}
                    excludedPoints={computeExcludedPointsToGraphic(
                      variableSelector3,
                      excludedPoints,
                      selected3
                    )}
                  /&gt;
                &lt;/div&gt;
              &lt;/div&gt;
            &lt;/div&gt;
          &lt;/div&gt;
        &lt;/div&gt;
        &lt;div&gt;
          &lt;div className={s.Fitting__infos}&gt;
            {selectedBatches.map((selectedBatch) =&gt; (
              &lt;React.Fragment key={selectedBatch}&gt;
                &lt;Info
                  title={`Kinetic Summary(${selectedBatch})`}
                  fields={[
                    {
                      name: &#x27;Growth Rate&#x27;,
                      value: formatIfNumber(
                        (fittingData?.kineticSummary as any)[selectedBatch]
                          ?.growth_parameters.primary_growth_rate
                      )
                    },
                    {
                      name: &#x27;Death Rate&#x27;,
                      value: formatIfNumber(
                        (fittingData?.kineticSummary as any)[selectedBatch]
                          ?.growth_parameters.primary_death_rate
                      )
                    },
                    {
                      name: &#x27;Toxicity&#x27;,
                      value: formatIfNumber(
                        (fittingData?.kineticSummary as any)[selectedBatch]
                          ?.growth_parameters.toxicity_rate
                      )
                    },
                    {
                      name: &#x27;Lysing Rate&#x27;,
                      value: formatIfNumber(
                        (fittingData?.kineticSummary as any)[selectedBatch]
                          ?.growth_parameters.lysing_rate
                      )
                    },
                    {
                      name: &#x27;Inhibition&#x27;,
                      value: formatIfNumber(
                        (fittingData?.kineticSummary as any)[selectedBatch]
                          ?.inhibitor_factors[0]?.threshold
                      )
                    }
                  ]}
                /&gt;
                &lt;Info
                  title={`Fit Statistics(${selectedBatch})`}
                  fields={[
                    {
                      name: &#x27;RSquare&#x27;,
                      value: fittingData?.fit_statistics?.[selectedBatch]
                        ?.r_squared
                        ? formatIfNumber(
                            fittingData?.fit_statistics?.[selectedBatch]
                              ?.r_squared
                          )
                        : &#x27;-&#x27;
                    },
                    // {
                    //   name: &#x27;RSquare adj&#x27;,
                    //   value: &#x27;-&#x27;
                    // },
                    {
                      name: &#x27;Root mean sq error&#x27;,
                      value: fittingData?.fit_statistics?.[selectedBatch]?.rmse
                        ? formatIfNumber(
                            fittingData?.fit_statistics?.[selectedBatch]?.rmse
                          )
                        : &#x27;-&#x27;
                    }
                  ]}
                /&gt;
              &lt;/React.Fragment&gt;
            ))}
          &lt;/div&gt;
        &lt;/div&gt;
      &lt;/div&gt;
    &lt;/div&gt;
  );
};
</textarea><pre id="annotations" style="display:none">[{&quot;file&quot;:&quot;src/pages/fitting/index.tsx&quot;,&quot;line&quot;:52,&quot;character&quot;:2,&quot;text&quot;:&quot;prepared&quot;,&quot;kind&quot;:2},{&quot;file&quot;:&quot;src/pages/fitting/index.tsx&quot;,&quot;line&quot;:56,&quot;character&quot;:9,&quot;text&quot;:&quot;prepared&quot;,&quot;kind&quot;:2},{&quot;file&quot;:&quot;src/pages/fitting/index.tsx&quot;,&quot;line&quot;:57,&quot;character&quot;:10,&quot;text&quot;:&quot;row&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/fitting/index.tsx&quot;,&quot;line&quot;:59,&quot;character&quot;:11,&quot;text&quot;:&quot;row&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/fitting/index.tsx&quot;,&quot;line&quot;:60,&quot;character&quot;:9,&quot;text&quot;:&quot;row&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/fitting/index.tsx&quot;,&quot;line&quot;:60,&quot;character&quot;:13,&quot;text&quot;:&quot;BatchID&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/fitting/index.tsx&quot;,&quot;line&quot;:60,&quot;character&quot;:23,&quot;text&quot;:&quot;row&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/fitting/index.tsx&quot;,&quot;line&quot;:64,&quot;character&quot;:34,&quot;text&quot;:&quot;acc&quot;,&quot;kind&quot;:2},{&quot;file&quot;:&quot;src/pages/fitting/index.tsx&quot;,&quot;line&quot;:65,&quot;character&quot;:15,&quot;text&quot;:&quot;acc&quot;,&quot;kind&quot;:2},{&quot;file&quot;:&quot;src/pages/fitting/index.tsx&quot;,&quot;line&quot;:68,&quot;character&quot;:40,&quot;text&quot;:&quot;row as any&quot;,&quot;kind&quot;:3},{&quot;file&quot;:&quot;src/pages/fitting/index.tsx&quot;,&quot;line&quot;:73,&quot;character&quot;:10,&quot;text&quot;:&quot;row&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/fitting/index.tsx&quot;,&quot;line&quot;:74,&quot;character&quot;:9,&quot;text&quot;:&quot;row&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/fitting/index.tsx&quot;,&quot;line&quot;:75,&quot;character&quot;:7,&quot;text&quot;:&quot;row&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/fitting/index.tsx&quot;,&quot;line&quot;:75,&quot;character&quot;:11,&quot;text&quot;:&quot;BatchID&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/fitting/index.tsx&quot;,&quot;line&quot;:75,&quot;character&quot;:21,&quot;text&quot;:&quot;row&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/fitting/index.tsx&quot;,&quot;line&quot;:77,&quot;character&quot;:11,&quot;text&quot;:&quot;a&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/fitting/index.tsx&quot;,&quot;line&quot;:77,&quot;character&quot;:14,&quot;text&quot;:&quot;b&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/fitting/index.tsx&quot;,&quot;line&quot;:77,&quot;character&quot;:20,&quot;text&quot;:&quot;a&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/fitting/index.tsx&quot;,&quot;line&quot;:77,&quot;character&quot;:22,&quot;text&quot;:&quot;Time&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/fitting/index.tsx&quot;,&quot;line&quot;:77,&quot;character&quot;:29,&quot;text&quot;:&quot;b&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/fitting/index.tsx&quot;,&quot;line&quot;:77,&quot;character&quot;:31,&quot;text&quot;:&quot;Time&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/fitting/index.tsx&quot;,&quot;line&quot;:107,&quot;character&quot;:6,&quot;text&quot;:&quot;y&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/fitting/index.tsx&quot;,&quot;line&quot;:123,&quot;character&quot;:4,&quot;text&quot;:&quot;dataKey&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/fitting/index.tsx&quot;,&quot;line&quot;:123,&quot;character&quot;:26,&quot;text&quot;:&quot;dataKey&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/fitting/index.tsx&quot;,&quot;line&quot;:124,&quot;character&quot;:4,&quot;text&quot;:&quot;id&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/fitting/index.tsx&quot;,&quot;line&quot;:124,&quot;character&quot;:21,&quot;text&quot;:&quot;id&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/fitting/index.tsx&quot;,&quot;line&quot;:126,&quot;character&quot;:4,&quot;text&quot;:&quot;y&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/fitting/index.tsx&quot;,&quot;line&quot;:158,&quot;character&quot;:31,&quot;text&quot;:&quot;id&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/fitting/index.tsx&quot;,&quot;line&quot;:160,&quot;character&quot;:13,&quot;text&quot;:&quot;id&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/fitting/index.tsx&quot;,&quot;line&quot;:161,&quot;character&quot;:29,&quot;text&quot;:&quot;id&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/fitting/index.tsx&quot;,&quot;line&quot;:162,&quot;character&quot;:26,&quot;text&quot;:&quot;id&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/fitting/index.tsx&quot;,&quot;line&quot;:163,&quot;character&quot;:39,&quot;text&quot;:&quot;id&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/fitting/index.tsx&quot;,&quot;line&quot;:164,&quot;character&quot;:31,&quot;text&quot;:&quot;id&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/fitting/index.tsx&quot;,&quot;line&quot;:170,&quot;character&quot;:8,&quot;text&quot;:&quot;mappedInitialData&quot;,&quot;kind&quot;:2},{&quot;file&quot;:&quot;src/pages/fitting/index.tsx&quot;,&quot;line&quot;:176,&quot;character&quot;:10,&quot;text&quot;:&quot;set&quot;,&quot;kind&quot;:2},{&quot;file&quot;:&quot;src/pages/fitting/index.tsx&quot;,&quot;line&quot;:177,&quot;character&quot;:6,&quot;text&quot;:&quot;mappedInitialData&quot;,&quot;kind&quot;:2},{&quot;file&quot;:&quot;src/pages/fitting/index.tsx&quot;,&quot;line&quot;:177,&quot;character&quot;:29,&quot;text&quot;:&quot;row&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/fitting/index.tsx&quot;,&quot;line&quot;:178,&quot;character&quot;:15,&quot;text&quot;:&quot;row&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/fitting/index.tsx&quot;,&quot;line&quot;:182,&quot;character&quot;:4,&quot;text&quot;:&quot;set&quot;,&quot;kind&quot;:2},{&quot;file&quot;:&quot;src/pages/fitting/index.tsx&quot;,&quot;line&quot;:182,&quot;character&quot;:17,&quot;text&quot;:&quot;v&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/fitting/index.tsx&quot;,&quot;line&quot;:182,&quot;character&quot;:32,&quot;text&quot;:&quot;v&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/fitting/index.tsx&quot;,&quot;line&quot;:184,&quot;character&quot;:26,&quot;text&quot;:&quot;mappedInitialData&quot;,&quot;kind&quot;:2},{&quot;file&quot;:&quot;src/pages/fitting/index.tsx&quot;,&quot;line&quot;:205,&quot;character&quot;:6,&quot;text&quot;:&quot;mappedInitialData&quot;,&quot;kind&quot;:2},{&quot;file&quot;:&quot;src/pages/fitting/index.tsx&quot;,&quot;line&quot;:205,&quot;character&quot;:32,&quot;text&quot;:&quot;acc&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/fitting/index.tsx&quot;,&quot;line&quot;:205,&quot;character&quot;:37,&quot;text&quot;:&quot;row&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/fitting/index.tsx&quot;,&quot;line&quot;:205,&quot;character&quot;:51,&quot;text&quot;:&quot;acc&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/fitting/index.tsx&quot;,&quot;line&quot;:205,&quot;character&quot;:59,&quot;text&quot;:&quot;row&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/fitting/index.tsx&quot;,&quot;line&quot;:207,&quot;character&quot;:6,&quot;text&quot;:&quot;mappedInitialData&quot;,&quot;kind&quot;:2},{&quot;file&quot;:&quot;src/pages/fitting/index.tsx&quot;,&quot;line&quot;:244,&quot;character&quot;:8,&quot;text&quot;:&quot;viableCellDensity&quot;,&quot;kind&quot;:2},{&quot;file&quot;:&quot;src/pages/fitting/index.tsx&quot;,&quot;line&quot;:247,&quot;character&quot;:8,&quot;text&quot;:&quot;mappedInitialData&quot;,&quot;kind&quot;:2},{&quot;file&quot;:&quot;src/pages/fitting/index.tsx&quot;,&quot;line&quot;:251,&quot;character&quot;:5,&quot;text&quot;:&quot;mappedInitialData&quot;,&quot;kind&quot;:2},{&quot;file&quot;:&quot;src/pages/fitting/index.tsx&quot;,&quot;line&quot;:254,&quot;character&quot;:8,&quot;text&quot;:&quot;viability&quot;,&quot;kind&quot;:2},{&quot;file&quot;:&quot;src/pages/fitting/index.tsx&quot;,&quot;line&quot;:256,&quot;character&quot;:21,&quot;text&quot;:&quot;mappedInitialData&quot;,&quot;kind&quot;:2},{&quot;file&quot;:&quot;src/pages/fitting/index.tsx&quot;,&quot;line&quot;:257,&quot;character&quot;:5,&quot;text&quot;:&quot;mappedInitialData&quot;,&quot;kind&quot;:2},{&quot;file&quot;:&quot;src/pages/fitting/index.tsx&quot;,&quot;line&quot;:260,&quot;character&quot;:8,&quot;text&quot;:&quot;variableSelector1&quot;,&quot;kind&quot;:2},{&quot;file&quot;:&quot;src/pages/fitting/index.tsx&quot;,&quot;line&quot;:262,&quot;character&quot;:26,&quot;text&quot;:&quot;mappedInitialData&quot;,&quot;kind&quot;:2},{&quot;file&quot;:&quot;src/pages/fitting/index.tsx&quot;,&quot;line&quot;:263,&quot;character&quot;:27,&quot;text&quot;:&quot;mappedInitialData&quot;,&quot;kind&quot;:2},{&quot;file&quot;:&quot;src/pages/fitting/index.tsx&quot;,&quot;line&quot;:265,&quot;character&quot;:8,&quot;text&quot;:&quot;variableSelector2&quot;,&quot;kind&quot;:2},{&quot;file&quot;:&quot;src/pages/fitting/index.tsx&quot;,&quot;line&quot;:267,&quot;character&quot;:26,&quot;text&quot;:&quot;mappedInitialData&quot;,&quot;kind&quot;:2},{&quot;file&quot;:&quot;src/pages/fitting/index.tsx&quot;,&quot;line&quot;:268,&quot;character&quot;:27,&quot;text&quot;:&quot;mappedInitialData&quot;,&quot;kind&quot;:2},{&quot;file&quot;:&quot;src/pages/fitting/index.tsx&quot;,&quot;line&quot;:270,&quot;character&quot;:8,&quot;text&quot;:&quot;variableSelector3&quot;,&quot;kind&quot;:2},{&quot;file&quot;:&quot;src/pages/fitting/index.tsx&quot;,&quot;line&quot;:272,&quot;character&quot;:26,&quot;text&quot;:&quot;mappedInitialData&quot;,&quot;kind&quot;:2},{&quot;file&quot;:&quot;src/pages/fitting/index.tsx&quot;,&quot;line&quot;:273,&quot;character&quot;:27,&quot;text&quot;:&quot;mappedInitialData&quot;,&quot;kind&quot;:2},{&quot;file&quot;:&quot;src/pages/fitting/index.tsx&quot;,&quot;line&quot;:284,&quot;character&quot;:10,&quot;text&quot;:&quot;notTransformed&quot;,&quot;kind&quot;:2},{&quot;file&quot;:&quot;src/pages/fitting/index.tsx&quot;,&quot;line&quot;:284,&quot;character&quot;:27,&quot;text&quot;:&quot;mappedInitialData&quot;,&quot;kind&quot;:2},{&quot;file&quot;:&quot;src/pages/fitting/index.tsx&quot;,&quot;line&quot;:285,&quot;character&quot;:15,&quot;text&quot;:&quot;row&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/fitting/index.tsx&quot;,&quot;line&quot;:286,&quot;character&quot;:37,&quot;text&quot;:&quot;row&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/fitting/index.tsx&quot;,&quot;line&quot;:286,&quot;character&quot;:41,&quot;text&quot;:&quot;BatchID&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/fitting/index.tsx&quot;,&quot;line&quot;:291,&quot;character&quot;:41,&quot;text&quot;:&quot;row&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/fitting/index.tsx&quot;,&quot;line&quot;:291,&quot;character&quot;:45,&quot;text&quot;:&quot;BatchID&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/fitting/index.tsx&quot;,&quot;line&quot;:291,&quot;character&quot;:68,&quot;text&quot;:&quot;row&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/fitting/index.tsx&quot;,&quot;line&quot;:291,&quot;character&quot;:72,&quot;text&quot;:&quot;Time&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/fitting/index.tsx&quot;,&quot;line&quot;:298,&quot;character&quot;:12,&quot;text&quot;:&quot;row&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/fitting/index.tsx&quot;,&quot;line&quot;:300,&quot;character&quot;:17,&quot;text&quot;:&quot;row&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/fitting/index.tsx&quot;,&quot;line&quot;:303,&quot;character&quot;:17,&quot;text&quot;:&quot;row&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/fitting/index.tsx&quot;,&quot;line&quot;:308,&quot;character&quot;:17,&quot;text&quot;:&quot;row&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/fitting/index.tsx&quot;,&quot;line&quot;:311,&quot;character&quot;:17,&quot;text&quot;:&quot;row&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/fitting/index.tsx&quot;,&quot;line&quot;:314,&quot;character&quot;:17,&quot;text&quot;:&quot;row&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/fitting/index.tsx&quot;,&quot;line&quot;:316,&quot;character&quot;:15,&quot;text&quot;:&quot;row&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/fitting/index.tsx&quot;,&quot;line&quot;:318,&quot;character&quot;:10,&quot;text&quot;:&quot;dataSet&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/fitting/index.tsx&quot;,&quot;line&quot;:322,&quot;character&quot;:15,&quot;text&quot;:&quot;selectedInSelectorBatch as string&quot;,&quot;kind&quot;:3},{&quot;file&quot;:&quot;src/pages/fitting/index.tsx&quot;,&quot;line&quot;:328,&quot;character&quot;:4,&quot;text&quot;:&quot;mappedInitialData&quot;,&quot;kind&quot;:2},{&quot;file&quot;:&quot;src/pages/fitting/index.tsx&quot;,&quot;line&quot;:646,&quot;character&quot;:25,&quot;text&quot;:&quot;fittingData?.kineticSummary as any&quot;,&quot;kind&quot;:3},{&quot;file&quot;:&quot;src/pages/fitting/index.tsx&quot;,&quot;line&quot;:647,&quot;character&quot;:28,&quot;text&quot;:&quot;growth_parameters&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/fitting/index.tsx&quot;,&quot;line&quot;:647,&quot;character&quot;:46,&quot;text&quot;:&quot;primary_growth_rate&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/fitting/index.tsx&quot;,&quot;line&quot;:653,&quot;character&quot;:25,&quot;text&quot;:&quot;fittingData?.kineticSummary as any&quot;,&quot;kind&quot;:3},{&quot;file&quot;:&quot;src/pages/fitting/index.tsx&quot;,&quot;line&quot;:654,&quot;character&quot;:28,&quot;text&quot;:&quot;growth_parameters&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/fitting/index.tsx&quot;,&quot;line&quot;:654,&quot;character&quot;:46,&quot;text&quot;:&quot;primary_death_rate&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/fitting/index.tsx&quot;,&quot;line&quot;:660,&quot;character&quot;:25,&quot;text&quot;:&quot;fittingData?.kineticSummary as any&quot;,&quot;kind&quot;:3},{&quot;file&quot;:&quot;src/pages/fitting/index.tsx&quot;,&quot;line&quot;:661,&quot;character&quot;:28,&quot;text&quot;:&quot;growth_parameters&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/fitting/index.tsx&quot;,&quot;line&quot;:661,&quot;character&quot;:46,&quot;text&quot;:&quot;toxicity_rate&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/fitting/index.tsx&quot;,&quot;line&quot;:667,&quot;character&quot;:25,&quot;text&quot;:&quot;fittingData?.kineticSummary as any&quot;,&quot;kind&quot;:3},{&quot;file&quot;:&quot;src/pages/fitting/index.tsx&quot;,&quot;line&quot;:668,&quot;character&quot;:28,&quot;text&quot;:&quot;growth_parameters&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/fitting/index.tsx&quot;,&quot;line&quot;:668,&quot;character&quot;:46,&quot;text&quot;:&quot;lysing_rate&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/fitting/index.tsx&quot;,&quot;line&quot;:674,&quot;character&quot;:25,&quot;text&quot;:&quot;fittingData?.kineticSummary as any&quot;,&quot;kind&quot;:3},{&quot;file&quot;:&quot;src/pages/fitting/index.tsx&quot;,&quot;line&quot;:675,&quot;character&quot;:28,&quot;text&quot;:&quot;inhibitor_factors&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/fitting/index.tsx&quot;,&quot;line&quot;:675,&quot;character&quot;:50,&quot;text&quot;:&quot;threshold&quot;,&quot;kind&quot;:1}]</pre></div>
    <p class="footer-text">TypeScript Coverage Report generated by <a href="https://github.com/plantain-00/type-coverage">type-coverage</a> and <a href="https://github.com/alexcanessa/typescript-coverage-report">typescript-coverage-report</a> at Tue, 05 Oct 2021 23:09:04 GMT</p>
    </body>
  </html>
  